<template>
  <div>
    <SearchAP
      :session-stored-application-profiles="sessionStoredApplicationProfiles"
      :token="token"
      @applicationProfiles="handleApplicationProfiles"
      @searching="searching"
    />
    <ListAPs
      :application-profiles="applicationProfiles"
      :search-running="searchRunning"
      :selected-application-profile="selectedApplicationProfile"
      @emptyApplicationProfile="emptyApplicationProfile"
      @selectApplicationProfile="selectApplicationProfile"
    />
  </div>
</template>

<script lang="ts">
import { ApplicationProfile } from "@/types/application-profile";

import { defineComponent, type PropType } from "vue";

export default defineComponent({
  name: "APSelection",
  props: {
    selectedApplicationProfile: {
      required: false,
      default: undefined,
      type: Object as PropType<ApplicationProfile | undefined>,
    },
    sessionStoredApplicationProfiles: {
      required: false,
      default: 0,
      type: Number,
    },
    token: {
      default: "",
      type: String,
    },
  },
  data() {
    return {
      applicationProfiles: [] as Array<ApplicationProfile>,
      searchRunning: false,
    };
  },
  methods: {
    emptyApplicationProfile() {
      this.$emit("emptyApplicationProfile");
    },
    handleApplicationProfiles(applicationProfiles: Array<ApplicationProfile>) {
      this.applicationProfiles = applicationProfiles;
    },
    searching(searchRunning: boolean) {
      this.searchRunning = searchRunning;
    },
    selectApplicationProfile(applicationProfile: ApplicationProfile) {
      this.$emit("selectApplicationProfile", applicationProfile);
    },
  },
});
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
